slc	equ 291

plo	equ 00c03h
phi	equ 08b03h
slo	equ 00d01h
shi	equ 08a01h
zlo	equ 00901h
zhi	equ 08e01h
olo	equ 00902h
ohi	equ 08e02h
llo	equ 00701h

bdp	equ 0c9bh
hdp	equ 01f80h

org 256

sta	mov ah,9
	mov dx,hlp
	int 21h
	cld
	mov si,80h
	lodsb
	cbw
	mov dx,si
	add si,ax
	inc dx
	mov ax,03d00h
	mov [si],al
	int 21h
	jnc ook
	mov dx,cof
	mov ah,9
	int 21h
	ret

ook	mov bp,ax
	mov ax,irq
	mov bx,cs
	call xve
	push ax
	mov [prt],dx
	inc dx
	inc dx
	mov al,4
	out dx,al
	mov ah,0fh
	push bx
	int 10h
	cbw
	push ax
	mov al,1
	int 10h

	mov al,036h
	out 43h,al
	mov al,slc-256*(slc/256)
	out 40h,al
	mov al,slc/256
	out 40h,al

	mov ax,0b800h
	mov es,ax
	xor di,di
	mov si,hea
	call wcs 

	in al,21h
	push ax
	or al,2
	out 21h,al	

tap	in al,60h
	shl al,1
	jnc tap
	std
	push ds
	push es
	pop ds
	mov di,1998
	mov si,1918
	mov cx,22*40
cbl	movsb
	dec si
	dec di
	loop cbl
	mov ax,01720h
	mov cl,40
	rep
	stosw
	cld
	pop ds
	mov ah,03fh
	mov bx,bp
	mov dx,dat
	mov cx,2
	int 21h
	mov si,erf
	jc exi
	and ax,ax
	mov si,eof
	jz exi
	cmp ax,2
	jc cfe
	mov ah,03fh
	mov cx,[dat]
	mov si,lbf
	cmp cx,49155
	jnc exi
	mov si,zbf
	cmp cx,2
	jc exi
	int 21h
	mov si,erf
	jc exi
	cmp ax,cx
	jc cfe
	push cx
	mov di,162
	mov si,dat
	call hwb
	mov dx,bdp/2
	shl al,1
	jc hls
	mov dx,hdp/2
	jnz hls
	inc di
	inc di
	call hwb
	inc di
	inc di
	mov cl,10
nam	movsb
	inc di
	loop nam
	inc di
	inc di
	call hww
	inc di
	inc di
	call hww
	inc di
	inc di
	call hww
	jmp short pil
cfe	mov si,crf
exi	jmp exp
can	in al,60h
	cmp al,128
	jnc rtn
	push ax
	mov di,226
	mov si,ski
	call wcs
	pop ax
	add al,255
rtn	ret
hls	mov di,196
	pop ax
	push ax
	sub ax,2
	call hwa
pil	mov cx,dx
	mov [es:226],byte 'P'
gpp	mov ax,plo
	call ins
	mov ax,phi
	call ins
	mov ax,cx
	mov di,230
	push cx
	call hwa
	pop cx
	call can
	jnc lag
	pop cx
	jz cbx
	jmp short ntb
lag	loop gpp
	pop cx
	mov [es:226],byte 'S'
	mov ax,slo
	call ins
	mov ax,shi
	call ins
	mov [es:226],byte 'B'
	mov si,dat
	mov ax,128
sby	push ax
	and al,[si]
	mov ax,zlo
	mov dx,zhi
	jz biz
	mov ax,olo
	mov dx,ohi
biz	call ins
	xchg ax,dx
	call ins
	pop ax
	ror al,1
	jnc sby
	xor ah,[si]
	inc si
	mov di,230
	push cx
	push ax
	mov ax,cx
	call hwa
	call can
	pop ax
	pop cx
	jnc nrt
	jz cbx
	jmp short ntb
nrt	loop sby
	push ax
	mov ax,llo
	call ins
	mov di,226
	mov si,sum
	call wcs
	pop ax
	call hwl
fin	mov ax,[spt]
	xor al,ah
	jnz fin
ntb	jmp tap

cbx	mov si,cbf
exp	pop ax
	out 21h,al
	mov ax,llo
	call ins
	mov ah,04fh
	mov di,160
	call wcs
	mov si,fil
	call wcs
fln	stosw
	cmp di,240
	jc fln

	mov al,036h
	out 43h,al
	mov al,0
	out 40h,al
	out 40h,al
	mov ah,8
	int 21h
	pop ax
	int 10h
	pop bx
	pop ax

xve	xor cx,cx
	mov es,cx
	cli
	xchg [es:32],ax
	xchg [es:34],bx
	mov [vec],ax
	mov [vec+2],bx
	sti
	mov dx,[es:408h]
	ret

ins	mov bh,bpg
	mov bl,[dpt]
	mov [bx],ax
	inc bx
	inc bx
inw	cmp bl,[spt]
	jz inw
	mov [dpt],bl
wex	ret	

hwb	lodsb
	mov ah,al
hwl	mov ch,2
	jmp short hwr
hww	lodsw
hwa	mov ch,4
hwr	mov cl,4h
hws	rol ax,cl
	push ax
	and al,0fh
	add al,90h
	daa
	adc al,40h
	daa
	stosb
	inc di
	pop ax
	dec ch
	jnz hws
	ret

wcl	jnz wex
	lodsb
	mov ah,al
wcs	lodsb
	cmp al,254
	jnc wcl
	stosw
	jmp short wcs

irq	push ax
	mov ax,[cs:spt]
	cmp al,ah
	jz irl
	mov ah,bpg
	push bx
	xchg ax,bx
	dec byte [cs:bx]
	jnz irw
	inc bx
	push es
	mov ax,0b800h
	mov es,ax
	mov al,[cs:bx]
	cbw
	and al,07fh
	mov [es:79],al
	mov [es:159],al	
	push dx
	mov dx,[cs:prt]
	mov al,ah
	out dx,al
	pop dx
	pop es
	inc bx
	mov [cs:spt],bl
irw	pop bx	
irl	mov al,020h
	out 020h,al	
	pop ax
	add word [cs:acu],slc
	jnc ire
	sti
	jmp far [cs:vec]
ire	iret

hea	db 254,1fh," TapToLpt v0.1 (C) Zilogat0r 2004 "
	db 254,1ch,16,254,1eh,16,254,1ah,16,254,1bh,16,' ',0dbh
	db 254,31h," FL",254,35h," TP",254,3fh," NAME      "
	db 254,31h," LEN ",254,35h," ADD ",254,34h," BAS  "
	db 254,3bh,"PULSE ",0dbh,255
sum	db "XOR ",255
ski	db 254,4fh,"SKIPPED",255
cbf	db " Cancelled inside",255
zbf	db " Block smaller than 2 bytes in",255
erf	db " Error reading",255
lbf	db " Block larger than 49154 bytes in",255
crf	db " Corrupted",255
eof	db " End of",255
fil	db " file ",255
cof	db "Cannot open input file!",0dh,0ah,'$'
hlp	db "TapToLpt v0.1",0dh,0ah
	db "Usage: taptolpt infile.tap (LPT1's Dxx -> ZX's EAR)"
end	db 0dh,0ah,'$'

acu	dw 0
spt	db 0
dpt	db 0

pad	
	absolute pad

prt	resw 1
vec	resw 2

bpg	equ 2+(vec+3-sta)/256
dat	equ 265*(bpg+1)